import {extractDate} from '../index.js';

const validData = [
    ["0011057646", "5th of November 1900"],
    ["0109268831", "26th of September 1901"],
    ["0208077731", "7th of August 1902"],
    ["0302047332", "4th of February 1903"],
    ["0303252727", "25th of March 1903"],
    ["0404151890", "15th of April 1904"],
    ["0503174935", "17th of March 1905"],
    ["0512017395", "1st of December 1905"],
    ["0604216788", "21st of April 1906"],
    ["0607209226", "20th of July 1906"],
    ["0907048293", "4th of July 1909"],
    ["1004287056", "28th of April 1910"],
    ["1011183712", "18th of November 1910"],
    ["1011188479", "18th of November 1910"],
    ["1201316184", "31st of January 1912"],
    ["1306045345", "4th of June 1913"],
    ["1311094513", "9th of November 1913"],
    ["1311100160", "10th of November 1913"],
    ["1312134415", "13th of December 1913"],
    ["1504105503", "10th of April 1915"],
    ["1606150491", "15th of June 1916"],
    ["1803291106", "29th of March 1918"],
    ["1907308387", "30th of July 1919"],
    ["1912086366", "8th of December 1919"],
    ["2002020144", "2nd of February 1920"],
    ["2109295189", "29th of September 1921"],
    ["2310198454", "19th of October 1923"],
    ["2504138957", "13th of April 1925"],
    ["3010031262", "3rd of October 1930"],
    ["3010216559", "21st of October 1930"],
    ["3105303781", "30th of May 1931"],
    ["3106041710", "4th of June 1931"],
    ["3106157634", "15th of June 1931"],
    ["3206181249", "18th of June 1932"],
    ["3508184269", "18th of August 1935"],
    ["3804145310", "14th of April 1938"],
    ["3809085153", "8th of September 1938"],
    ["4010073505", "7th of October 1940"],
    ["4112230660", "23rd of December 1941"],
    ["4206232733", "23rd of June 1942"],
    ["4407294125", "29th of July 1944"],
    ["4409281003", "28th of September 1944"],
    ["4410305966", "30th of October 1944"],
    ["4511309614", "30th of November 1945"],
    ["4609155893", "15th of September 1946"],
    ["4703252225", "25th of March 1947"],
    ["4901273165", "27th of January 1949"],
    ["5210044342", "4th of October 1952"],
    ["5512267834", "26th of December 1955"],
    ["5603143773", "14th of March 1956"],
    ["5701220051", "22nd of January 1957"],
    ["5702282736", "28th of February 1957"],
    ["5909140643", "14th of September 1959"],
    ["5910118800", "11th of October 1959"],
    ["6001091990", "9th of January 1960"],
    ["6201157564", "15th of January 1962"],
    ["6201164769", "16th of January 1962"],
    ["6305143794", "14th of May 1963"],
    ["6307218969", "21st of July 1963"],
    ["6311299620", "29th of November 1963"],
    ["6604179113", "17th of April 1966"],
    ["6709033640", "3rd of September 1967"],
    ["7012027000", "2nd of December 1970"],
    ["7105199490", "19th of May 1971"],
    ["7202142540", "14th of February 1972"],
    ["7409027421", "2nd of September 1974"],
    ["7812017212", "1st of December 1978"],
    ["7905210962", "21st of May 1979"],
    ["8002249620", "24th of February 1980"],
    ["8104234134", "23rd of April 1981"],
    ["8204142535", "14th of April 1982"],
    ["8206299328", "29th of June 1982"],
    ["8309255353", "25th of September 1983"],
    ["8405279200", "27th of May 1984"],
    ["8611051114", "5th of November 1986"],
    ["8909223928", "22nd of September 1989"],
    ["8911030004", "3rd of November 1989"],
    ["8911055039", "5th of November 1989"],
    ["9007154350", "15th of July 1990"],
    ["9109143450", "14th of September 1991"],
    ["9112315175", "31st of December 1991"],
    ["9207068048", "6th of July 1992"],
    ["9207123119", "12th of July 1992"],
    ["9605204350", "20th of May 1996"],
    ["9709244062", "24th of September 1997"],
    ["9803027058", "2nd of March 1998"],
    ["9906177610", "17th of June 1999"],
    ["0004141060", "14th of April 1900"],
    ["0009096214", "9th of September 1900"],
    ["0103075901", "7th of March 1901"],
    ["0202252631", "25th of February 1902"],
    ["0209044769", "4th of September 1902"],
    ["0305038484", "3rd of May 1903"],
    ["0408292773", "29th of August 1904"],
    ["0501227445", "22nd of January 1905"],
    ["0704187852", "18th of April 1907"],
    ["0708235115", "23rd of August 1907"],
    ["0911135417", "13th of November 1909"],
    ["0912309196", "30th of December 1909"],
    ["9912319996", "31st of December 1999"],
];

const invalidData = [
    null,
    "",
    " ",
    "0",
    "123",
    "123456789",
    "1234567890",
    "12345678900",
    "123456789",
    "7804320594",
    "7813240594",
    "7811000594",
    "-800240594",
    "k800240594",
    "320?307332",
]

describe('Invalid data', () => {
    invalidData.forEach((eng) => {
        it(`expect ${eng} to be invalid`, () => {
            expect(extractDate(eng)).toEqual(false);
        });
    });
});
describe('Valid data', () => {
    validData.forEach(([eng, date]) => {
        it(`expect ${eng} => ${date}`, () => {
            expect(extractDate(eng)).toEqual(date);
        });
    });
});
